"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationWidget = void 0;
var react_1 = __importDefault(require("react"));
var widget_util_1 = require("./widget-util");
var types_1 = require("../types");
var Txt_1 = require("../../Txt");
var date_fns_1 = require("date-fns");
exports.DurationWidget = (0, widget_util_1.widgetFactory)('Duration', {}, [types_1.JsonTypes.object])(function (_a) {
    var value = _a.value;
    var duration = react_1.default.useMemo(function () {
        var _a, _b, _c;
        if (!value.start || !value.end) {
            return '';
        }
        var interval = (0, date_fns_1.intervalToDuration)({
            start: new Date(value.start),
            end: new Date(value.end),
        });
        if (!interval) {
            return '';
        }
        var customInterval = {};
        for (var _i = 0, _d = Object.entries(interval); _i < _d.length; _i++) {
            var _e = _d[_i], key = _e[0], value_1 = _e[1];
            if (value_1 == null) {
                continue;
            }
            customInterval[key] = value_1 < 10 ? "0".concat(value_1) : "".concat(value_1);
        }
        var durationText = '';
        if (!!interval.years) {
            durationText += "".concat(customInterval.years, "y ");
        }
        if (durationText.length > 0 || !!interval.months) {
            durationText += "".concat(customInterval.months, "m ");
        }
        if (durationText.length > 0 || !!interval.days) {
            durationText += "".concat(customInterval.days, "d ");
        }
        (_a = customInterval.hours) !== null && _a !== void 0 ? _a : (customInterval.hours = '00');
        (_b = customInterval.minutes) !== null && _b !== void 0 ? _b : (customInterval.minutes = '00');
        (_c = customInterval.seconds) !== null && _c !== void 0 ? _c : (customInterval.seconds = '00');
        durationText += "".concat(customInterval.hours, ":").concat(customInterval.minutes, ":").concat(customInterval.seconds);
        return durationText;
    }, []);
    return react_1.default.createElement(Txt_1.Txt, null, duration);
});
